DROP VIEW V_POGODBE;

CREATE OR REPLACE VIEW V_POGODBE AS (
	SELECT P.ID_POGODBE AS V_POGODBE_ID, P.ID_POGODBE, P.ID_LASTNIKA, P.ID_PLOVILA, P.ID_MASTER, P.OBJEKT, P.N_PRIVEZA, P.N_POGODBE, P.DATUM_ZACETKA, P.DATUM_KONCA, P.PREDVIDENI_DATUM_KONCA, P.DATUM_KREIRANJA, P.USER_KREIRANJA,
  P.DATUM_SPREMEMBE, P.USER_SPREMEMBE, P.STATUS, P.DATUM_SKLENITVE, P.DATUM_PREKINITVE, P.KOMENTAR, P.TIP_POGODBE, P.EXTENSION_SEQUENCE_NUMBER, P.EXTENSION_DATE,
  NNSTAT.OPIS AS STATUS_OPIS, NNSTAT.INTERNI_OPIS AS STATUS_INTERNI_OPIS,
  KUPVRS.VRSTA AS CURRENT_KUPCI_VRSTA, PLOV.IME AS PLOVILA_IME, PLOV.PODALJSA AS PLOVILA_PODALJSA, KUP.IME AS KUPCI_IME, KUP.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KUP.IME || ' ' || KUP.PRIIMEK) ELSE (KUP.PRIIMEK || ' ' || KUP.IME) END) AS OWNER,
  NP.ID_PRIVEZ AS NNPRIVEZ_ID_PRIVEZ, NP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NO.STORAGE AS NNOBJEKT_STORAGE,
  NNLOC.ID AS NNLOCATION_ID
	FROM M_POGODBE P
	LEFT OUTER JOIN NNSTATPOG NNSTAT ON P.STATUS = NNSTAT.SIFRA
  LEFT OUTER JOIN PLOVILA PLOV ON PLOV.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KUP ON KUP.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NNPRIVEZ NP ON P.OBJEKT = NP.OBJEKT AND P.N_PRIVEZA = NP.N_PRIVEZA
  LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = NP.OBJEKT 
  LEFT OUTER JOIN NNPOMOL NPOM ON NPOM.SIFRA = NP.KATEGORIJA
  LEFT OUTER JOIN NNLOCATION NNLOC ON NNLOC.ID = NPOM.NNLOCATION_ID
  LEFT OUTER JOIN (SELECT KUPCI_VRSTA.*, RANK() OVER (PARTITION BY ID_KUPCA ORDER BY ID_KUPCI_VRSTA DESC) RNK FROM KUPCI_VRSTA) KUPVRS ON (KUPVRS.ID_KUPCA = P.ID_LASTNIKA AND KUPVRS.RNK = 1)
);

DROP VIEW V_SALDKONT;

CREATE OR REPLACE VIEW V_SALDKONT AS (
	SELECT S.ID_SALDKONT AS SALDKONT_ID_SALDKONT, S.N_RACUNA AS SALDKONT_N_RACUNA, S.DATUM AS SALDKONT_DATUM, S.ZA_PLACILO AS SALDKONT_ZA_PLACILO, S.PORABLJENO AS SALDKONT_PORABLJENO, S.VALUTA_RN AS SALDKONT_VALUTA_RN,
  S.DATUM_VALUTACIJE AS SALDKONT_DATUM_VALUTACIJE, S.VRSTA_RACUNA AS SALDKONT_VRSTA_RACUNA, S.USER_KREIRANJA AS SALDKONT_USER_KREIRANJA, S.DATUM_KREIRANJA AS SALDKONT_DATUM_KREIRANJA,
  S.USER_SPREMEMBE AS SALDKONT_USER_SPREMEMBE, S.DATUM_SPREMEMBE AS SALDKONT_DATUM_SPREMEMBE, S.ID_KUPCA AS SALDKONT_ID_KUPCA, S.ID_PLOVILA AS SALDKONT_ID_PLOVILA, S.ZAPRTO AS SALDKONT_ZAPRTO,
  S.SDK_RN_PL AS SALDKONT_SDK_RN_PL, S.SDK_RN_TIP AS SALDKONT_SDK_RN_TIP, S.LASTNIK_OBVESCEN AS SALDKONT_LASTNIK_OBVESCEN, S.STORNO AS SALDKONT_STORNO, S.KOMENTAR AS SALDKONT_KOMENTAR, S.ID_CARDS AS SALDKONT_ID_CARDS, S.ZNESEK AS SALDKONT_ZNESEK,
  S.PROTIVREDNOST AS SALDKONT_PROTIVREDNOST, CASE WHEN S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) THEN 'Y' ELSE 'N' END AS SALDKONT_DOMESTIC, S.TECAJ_PRERACUN AS SALDKONT_TECAJ_PRERACUN, S.N_KNJIZBE AS SALDKONT_N_KNJIZBE,
  CASE WHEN S.SDK_RN_TIP = 'P' AND EXISTS (SELECT * FROM SALDKONT WHERE ID_SALDKONT = S.ID_SALDKONT_GEN AND SDK_RN_TIP = 'I' AND ZAPRTO = 1) THEN 'Y' ELSE 'N' END AS REC_INV_HAS_CLOSED_ISSUED_INV, 
  S.NCARD AS SALDKONT_NCARD, S.N_LISTINE AS SALDKONT_NLISTINE, S.NNLOCATION_ID AS SALDKONT_NNLOCATION_ID, S.NNFIRMA_ID AS SALDKONT_NNFIRMA_ID, S.ID_DN AS SALDKONT_ID_DN, 
  S.PAYMENT_RESPONSE_ID AS SALDKONT_PAYMENT_RESPONSE_ID, S.STATUS AS SALDKONT_STATUS, S.ID_SALDKONT_GEN AS SALDKONT_ID_SALDKONT_GEN, S.ID_EXCHANGE AS SALDKONT_ID_EXCHANGE, S.ID_RACUNA AS SALDKONT_ID_RACUNA,
  S.ID_BATCH AS SALDKONT_ID_BATCH, S.DAVEK_NA_STORITVE AS SALDKONT_DAVEK_NA_STORITVE, S.DAVEK_NA_MATERIAL AS SALDKONT_DAVEK_NA_MATERIAL, S.POPUST AS SALDKONT_POPUST, S.DATUM_ORG AS SALDKONT_DATUM_ORG, 
  S.DATUM_PLACILA AS SALDKONT_DATUM_PLACILA, S.VALUTA_PL AS SALDKONT_VALUTA_PL, S.TECAJ_PL AS SALDKONT_TECAJ_PL, S.TECAJ_VALUTE AS SALDKONT_TECAJ_VALUTE, S.STORNONR AS SALDKONT_STORNO_NR, 
  S.BLAGAJNA AS SALDKONT_BLAGAJNA, S.LOKAC AS SALDKONT_LOKAC, S.TRANSACTION_EXPORT_NR AS SALDKONT_TRANSACTION_EXPORT_NR, SF.GOVERNMENT_CODE AS SALDKONT_FISC_GOVERNMENT_CODE,
  R.SUBLEASE_OD AS RACUN_DATA_SUBLEASE_OD, R.SUBLEASE_DO AS RACUN_DATA_SUBLEASE_DO, N.OPIS AS M_NNSTOMAR_OPIS, N.KAT AS M_NNSTOMAR_KAT, N.TIMEKAT AS M_NNSTOMAR_TIMEKAT, N.SUBLEASE AS M_NNSTOMAR_SUBLEASE,
  D.ID_PRINT_DOK AS PRINT_DOK_ID_PRINT_DOK, D.STEVILKA AS PRINT_DOK_STEVILKA, D.OPIS AS PRINT_DOK_OPIS, D.DATOTEKA AS PRINT_DOK_DATOTEKA, D.PDF AS PRINT_DOK_PDF, D.OBJAVI AS PRINT_DOK_OBJAVI,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.SALDAKONTI_SIT AS KUPCI_SALDAKONTI_SIT, K.NASLOV AS KUPCI_NASLOV, K.POSTA AS KUPCI_POSTA, K.MESTO AS KUPCI_MESTO, K.DAVCNA_STEVILKA AS KUPCI_DAVCNA_STEVILKA,
  K.SIFRA_DOB AS KUPCI_SIFRA_DOB, K.INT_CODE AS KUPCI_INT_CODE, K.SEND_EMAILS AS KUPCI_SEND_EMAILS, K.N_KK AS KUPCI_N_KK, 
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  P.IME AS PLOVILA_IME, KND.OZNAKA AS KUPCI_NDRZAVA_OZNAKA, NC.OPIS AS NNCARDS_OPIS, NC.VRSTA_DENARJA AS NNCARDS_VRSTA_DENARJA, 
  M.ID_PRIVEZ AS M_STORITVE_ID_PRIVEZ, NNP.N_PRIVEZA AS M_STORITVE_NNPRIVEZ_N_PRIVEZA, M.SUBLEASE_PAYMENT AS M_STORITVE_SUBLEASE_PAYMENT, NKNJ.SLO AS NKNJIZBA_OPIS, NKNJ.INTERNI_OPIS AS NKNJIZBA_INTERNI_OPIS, 
  NKNJ.DEPOSIT AS NKNJIZBA_DEPOSIT, PR.STATUS_CODE AS PAYMENT_RESPONSE_STATUS_CODE, PR.MESSAGE AS PAYMENT_RESPONSE_MESSAGE, PR.INTERNAL_STATUS AS PAYMENT_RESPONSE_INT_STATUS
	FROM SALDKONT S
  LEFT OUTER JOIN SALDKONT_FISC SF ON SF.ID_SALDKONT = S.ID_SALDKONT
  LEFT OUTER JOIN RACUN_DATA R ON R.ID_SALDKONT = S.ID_SALDKONT
  LEFT OUTER JOIN M_STORITVE M ON M.ID_STORITVE = R.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR N ON N.SIFRA = M.STORITEV
  LEFT OUTER JOIN PRINT_DOK D ON D.MODUL = S.VRSTA_RACUNA AND D.REFERENCA = S.ID_SALDKONT
  LEFT OUTER JOIN KUPCI K ON K.ID = S.ID_KUPCA
  LEFT OUTER JOIN PLOVILA P ON P.ID = S.ID_PLOVILA
  LEFT OUTER JOIN NNCARDS NC ON NC.ID_CARDS = S.ID_CARDS
  LEFT OUTER JOIN NNDRZAVE KND ON KND.SIFRA = K.NDRZAVA
  LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = M.ID_PRIVEZ
  LEFT OUTER JOIN NKNJIZBA NKNJ ON NKNJ.SALDKONT = S.VRSTA_RACUNA
  LEFT OUTER JOIN PAYMENT_RESPONSE PR ON PR.ID = S.PAYMENT_RESPONSE_ID
  WHERE R.ZAP_ST IS NULL OR R.ZAP_ST = 1
);

DROP VIEW V_STORITVE;

CREATE OR REPLACE VIEW V_STORITVE AS (
	SELECT M.ID_STORITVE, M.ID_DN, M.ID_POGODBE, M.ID_VPS, M.VRSTA, M.ID_LASTNIKA, M.ID_PLOVILA, M.STORITEV, M.KAT, M.TIMEKAT, M.PROCKAT, M.DATUM_OD, M.DATUM_DO, M.KOLICINA, M.POPUST, M.OPIS_SERVIS,
  M.ZNESEK, M.VALUTA, M.TECAJ, M.DAVEK, M.N_PONUDBE, M.N_RACUNA, M.DATUM_RACUNA, M.ZAKLJUCEN, M.KOMENTAR, M.DATUM_KREIRANJA, M.USER_KREIRANJA, M.DATUM_SPREMEMBE, M.USER_SPREMEMBE, M.TIP_SERVIS, M.AUTO,
  M.POPUST1, M.POPUST2, M.NAMENP, M.NAMENP1, M.NAMENP2, M.TECAJP, M.DODATNA_STORITEV, M.DOMACA_VALUTA, M.PROVIZIJA, M.DRZAVA, M.SKUPAJ_OSEB, M.ID_KAT, M.PROVIZIJA_DELITEV, M.ID_REZERVACIJE, M.CUSTOM,
  M.CPROVIZIJA, M.SERVICE_COST, M.COMPLETE, M.KOLICINA_INSTR, M.ID_STORITVE_GEN, M.ID_BATCH, M.ID_SALDKONT, M.ID_LASTNIKA_ORG, M.NNLOCATION_ID, M.MIN_FEE, M.ID_LASTNIK_LEASE, 
  M.NCARD, M.FULL_AMOUNT, M.SERVICE_TIME, M.ID_PRIVEZ, M.SUBLEASE_PAYMENT, M.ID_DAVEK, M.LASTNIK_LEASE_PROCENT, M.ID_REZERVACIJE_CHARTER, M.ID_SERVICE_TEMPLATE, M.CAS_OD, M.CAS_DO, M.USER_COMMENT, M.SERVICE_COMMENT,
  M.ID_OWNER_SIGNATURE, M.ID_NAJAVE, M.SORT, M.ID_IMPORT_BATCH, M.CALCULATING, M.CALCULATED_TO, M.ID_STORITVE_STORNO,
  NS.OPIS AS NNSTOMAR_OPIS, NS.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, NS.DAVEK AS NNSTOMAR_DAVEK, NS.KAT AS NNSTOMAR_KAT, NS.TIMEKAT AS NNSTOMAR_TIMEKAT, NS.ENOTA AS NNSTOMAR_ENOTA, NS.FILTER AS NNSTOMAR_FILTER,
  NS.DEPARTURE_CHECK AS NNSTOMAR_DEPARTURE_CHECK, NS.NIGHTS_PRICE AS NNSTOMAR_NIGHTS_PRICE,
  NNE.OPIS AS NNSTOMAR_ENOTA_OPIS, NNE.INTERNI_OPIS AS NNSTOMAR_ENOTA_INTERNI_OPIS, MDN.DATUM_DN AS M_DE_NA_DATUM_DN, MDN.TERMIN_DO AS M_DE_NA_TERMIN_DO, MDN.STEVILKA AS M_DE_NA_STEVILKA,
  MDN.STATUS AS M_DE_NA_STATUS, MDN.ORG_STATUS AS M_DE_NA_ORG_STATUS, PL.IME AS PLOVILA_IME,
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK, KU.MANAGER AS KUPCI_MANAGER, KU.VRSTA AS KUPCI_VRSTA,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER
	FROM M_STORITVE M
  LEFT OUTER JOIN M_NNSTOMAR NS ON NS.SIFRA = M.STORITEV
  LEFT OUTER JOIN NNENOTE NNE ON NNE.SIFRA = NS.ENOTA
  LEFT OUTER JOIN M_DE_NA MDN ON MDN.ID_DN = M.ID_DN
  LEFT OUTER JOIN KUPCI KU ON KU.ID = M.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = M.ID_PLOVILA
);

DROP VIEW V_KUPCI_PLOVILA;

CREATE OR REPLACE VIEW V_KUPCI_PLOVILA AS (
  SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
  K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.ACT AS KUPCI_ACT, K.TELEX AS KUPCI_TELEX, K.GSM AS KUPCI_GSM, K.TELEFON_2 AS KUPCI_TELEFON_2, 
  K.DAVCNA_STEVILKA AS KUPCI_DAVCNA_STEVILKA, K.VALUTA_PLACILA AS KUPCI_VALUTA_PLACILA, K.SALDAKONTI_SIT AS KUPCI_SALDAKONTI_SIT, K.SALDAKONTI_DEM AS KUPCI_SALDAKONTI_DEM, K.SALDAKONTI_KOM AS KUPCI_SALDAKONTI_KOM, K.INT_CODE AS KUPCI_INT_CODE,
  K.VEHICLE_REGISTRATION_NUM AS KUPCI_VEHICLE_REGISTRATION_NUM, K.MANAGER AS KUPCI_MANAGER, 
 (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL, P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNI_OBJEKT_PRIVEZA, P.TRENUTNA_N_PRIVEZA, P.TRENUTNO_DO, 
  P.POGODBENI_OBJEKT_PRIVEZA, P.POGODBENA_N_PRIVEZA, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA, P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING, P.ACT AS PLOVILA_ACT, NNUSR.USER_ AS KUPCI_MANAGER_USER,
  VPT.ID_PRIVEZ AS ID_PRIVEZ_TEMP, VPT.NNLOCATION_ID AS ID_LOCATION_TEMP, VPC.ID_PRIVEZ AS ID_PRIVEZ_CONTRACT, VPC.NNLOCATION_ID AS ID_LOCATION_CONTRACT
  FROM KUPCI K
  LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
  LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPT ON VPT.OBJEKT = P.TRENUTNI_OBJEKT_PRIVEZA AND VPT.N_PRIVEZA = P.TRENUTNA_N_PRIVEZA
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPC ON VPC.OBJEKT = P.POGODBENI_OBJEKT_PRIVEZA AND VPC.N_PRIVEZA = P.POGODBENA_N_PRIVEZA
);

DROP VIEW V_BERTH_OWNER;

CREATE OR REPLACE VIEW V_BERTH_OWNER AS (
SELECT BO.ID, BO.ID_PRIVEZ, BO.ID_LASTNIKA, BO.DATE_FROM, BO.DATE_TO, BO.DATE_CREATED, BO.USER_CREATED, BO.DATE_CHANGED, BO.USER_CHANGED, BO.STATUS, BO."COMMENT", BO.TYPE,
BOT.OPIS AS BERTH_OWNER_TYPE_OPIS, BOT.INTERNI_OPIS AS BERTH_OWNER_TYPE_INTERNI_OPIS, 
NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NP.SORT AS NNPRIVEZ_SORT, NP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, PO.NAZIV AS NNPOMOL_NAZIV, PO.NNLOCATION_ID,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,  
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM BERTH_OWNER BO
LEFT OUTER JOIN BERTH_OWNER_TYPE BOT ON BOT.ID = BO.TYPE
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = BO.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL PO ON PO.SIFRA = NP.KATEGORIJA
LEFT OUTER JOIN KUPCI K ON K.ID = BO.ID_LASTNIKA
);

DROP VIEW V_BERTH_SUBLEASE;

CREATE OR REPLACE VIEW V_BERTH_SUBLEASE AS (
SELECT BS.ID, BS.ID_PRIVEZ, BS.ID_LASTNIKA, BS.ID_CARDS, BS.DATE_FROM, BS.DATE_TO, BS.DATE_CREATED, BS.USER_CREATED, BS.DATE_CHANGED, BS.USER_CHANGED,
NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NP.SORT AS NNPRIVEZ_SORT, NP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, NP.SUBLEASE AS NNPRIVEZ_SUBLEASE, 
(CASE WHEN NP.ID_BERTH_SUBLEASE = BS.ID AND NP.SUBLEASE = 'Y' THEN 'Y' ELSE 'N' END) AS SUBLEASE_ACTIVE, PO.NAZIV AS NNPOMOL_NAZIV, PO.NNLOCATION_ID,
NC.OPIS AS NNCARDS_OPIS, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM BERTH_SUBLEASE BS
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = BS.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL PO ON PO.SIFRA = NP.KATEGORIJA
LEFT OUTER JOIN KUPCI K ON K.ID = BS.ID_LASTNIKA
LEFT OUTER JOIN NNCARDS NC ON NC.ID_CARDS = BS.ID_CARDS
);

DROP VIEW V_DATOTEKE_KUPCEV;

CREATE OR REPLACE VIEW V_DATOTEKE_KUPCEV AS (
SELECT D.ID_DATOTEKE_KUPCEV, D.ID_KUPCA, D.VRSTA, D.DATOTEKA, D.IME_DATOTEKE, D.KONCNICA, D.KOMENTAR, D.USER_KREIRANJA, D.DATUM_KREIRANJA, 
D.USER_SPREMEMBE, D.DATUM_SPREMEMBE, D.STATUS, D.VALID, D.FILE_REFERENCE, D.ID_POGODBE, D.ISSUE_DATE,
N.OPIS AS VRSTA_OPIS, N.INTERNI_OPIS AS VRSTA_INTERNI_OPIS, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM DATOTEKE_KUPCEV D
LEFT OUTER JOIN NNDATOTEKE_KUPCEV_VRSTA N ON N.SIFRA = D.VRSTA
LEFT OUTER JOIN KUPCI K ON K.ID = D.ID_KUPCA
);

DROP VIEW V_DOGODKI;

CREATE OR REPLACE VIEW V_DOGODKI AS (
  SELECT D.ID, D.ID_LASTNIKA, D.ID_PLOVILA, D.DATUM_ZACETKA, D.KATEGORIJA_DOGODKA, D.LAST_PORT, D.OBJEKT, D.N_PRIVEZA, D.STORITEV, D.N_POGODBE, D.PREDVIDENI_DATUM_KONCA, D.DATUM_KONCA, 
  D.DATUM_KREIRANJA, D.USER_KREIRANJA, D.DATUM_SPREMEMBE, D.USER_SPREMEMBE, D.ID_RFID_DATA, D.DAILY, D.ID_PRIVEZ_FROM,
  ND.OPIS AS NDOGODEK_OPIS, ND.INTERNI_OPIS AS NDOGODEK_INTERNI_OPIS,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, P.IME AS PLOVILA_IME, P.POGODBENA_N_PRIVEZA, VP.NNLOCATION_ID AS NNLOCATION_ID, NP.ID_PRIVEZ, 
  NP_FROM.OBJEKT AS NNPRIVEZ_FROM_OBJEKT, NP_FROM.N_PRIVEZA AS NNPRIVEZ_FROM_PRIVEZ, VP_FROM.NNLOCATION_ID AS NNLOCATION_ID_FROM
	FROM DOGODKI D
  LEFT OUTER JOIN NDOGODEK ND ON ND.NDOGODEK = D.KATEGORIJA_DOGODKA
  LEFT OUTER JOIN KUPCI K ON K.ID = D.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA P ON P.ID = D.ID_PLOVILA
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON (VP.OBJEKT = D.OBJEKT AND VP.N_PRIVEZA = D.N_PRIVEZA)
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VP_FROM ON VP_FROM.ID_PRIVEZ = D.ID_PRIVEZ_FROM
  LEFT OUTER JOIN NNPRIVEZ NP ON (NP.OBJEKT = D.OBJEKT AND NP.N_PRIVEZA = D.N_PRIVEZA)
  LEFT OUTER JOIN NNPRIVEZ NP_FROM ON NP_FROM.ID_PRIVEZ = D.ID_PRIVEZ_FROM
);

DROP VIEW V_EMAIL;

CREATE OR REPLACE VIEW V_EMAIL
AS (
SELECT E.ID_EMAIL, E.DATUM_KREIRANJA, E.USER_KREIRANJA, E.ZADEVA, E.POSILJATELJ, E.STATUS, E.DATUM_POSILJANJA, E.AVTOMATSKO_KREIRANJE, E.PREJEMNIK_CC, 
E.PREJEMNIK_BCC, E.PREJEMNIK, E.TEKST, E.MESSAGE_ID, E.DATUM_PREJEMA, E.PREBRANO, E.STATUS_MESSAGE, K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM EMAILS E
LEFT OUTER JOIN (SELECT ID_KUPCA, ID_EMAIL, NPISMO, RANK() OVER (PARTITION BY ID_EMAIL ORDER BY ID_OPOMINI ASC) RNK FROM OPOMINI) O ON (O.ID_EMAIL = E.ID_EMAIL AND O.RNK = 1 AND O.NPISMO = 'E')
LEFT OUTER JOIN KUPCI K ON O.ID_KUPCA = K.ID
);

DROP VIEW V_FINAL_DEPARTURE;

CREATE OR REPLACE VIEW V_FINAL_DEPARTURE AS (
SELECT F.ID, F.ID_LASTNIKA, F.ID_PLOVILA, F.DEPARTURE_DATE, F.COMPLETED, F.REASON, F.MESSAGE, F.STATUS,
DS.OPIS AS FD_STATUS_OPIS, DS.INTERNI_OPIS AS FD_STATUS_INTERNI_OPIS, P.IME AS PLOVILA_IME, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM FINAL_DEPARTURE F
LEFT OUTER JOIN NNFINAL_DEPARTURE_STATUS DS ON DS.SIFRA = F.STATUS
LEFT OUTER JOIN PLOVILA P ON P.ID = F.ID_PLOVILA
LEFT OUTER JOIN KUPCI K ON K.ID = F.ID_LASTNIKA
);

DROP VIEW V_KUPCI_ACTIVITY;

CREATE OR REPLACE VIEW V_KUPCI_ACTIVITY AS (
SELECT KA.ID_KUPCI_ACTIVITY, K.ID AS KUPCI_ID, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.MANAGER AS KUPCI_MANAGER, 
K.VRSTA AS KUPCI_VRSTA, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
A.ID_ACTIVITY AS ID_ACTIVITY, A.DATE_FROM AS ACTIVITY_DATE_FROM, A.DATE_TO AS ACTIVITY_DATE_TO, A.ACTIVITY_TYPE, A.DESCRIPTION AS ACTIVITY_DESCRIPTION, A.STATUS AS ACTIVITY_STATUS,
A.DATE_CREATED AS ACTIVITY_DATE_CREATED, A.USER_CREATED AS ACTIVITY_USER_CREATED, A.DATE_CHANGED AS ACTIVITY_DATE_CHANGED, A.USER_CHANGED AS ACTIVITY_USER_CHANGED, A.COMPLETED AS ACTIVITY_COMPLETED, 
A.AUTO_CREATE AS ACTIVITY_AUTO_CREATE, A.SOURCE AS ACTIVITY_SOURCE, AT.OPIS AS ACTIVITY_TYPE_OPIS, AT.INTERNI_OPIS AS ACTIVITY_TYPE_INTERNI_OPIS, AT.AKT AS ACTIVITY_TYPE_AKT
FROM KUPCI_ACTIVITY KA
JOIN KUPCI K ON K.ID = KA.ID_KUPCA
JOIN ACTIVITY A ON A.ID_ACTIVITY = KA.ID_ACTIVITY
LEFT OUTER JOIN NNACTIVITY_TYPE AT ON AT.ID_NNACTIVITY_TYPE = A.ACTIVITY_TYPE
);

DROP VIEW V_KUPCIBELEZKE;

CREATE OR REPLACE VIEW V_KUPCIBELEZKE AS (
SELECT KB.ID_KPBELEZKE, KB.IDKUPCA, KB.DATUMKREIRANJA, KB.USERKREIRANJA, KB.BELEZKA, KB.VELJAVNA, KB.TYPE, KB.SUBTYPE,
KBT.OPIS AS BELEZKE_TYPE_OPIS, KBT.INTERNI_OPIS AS BELEZKE_TYPE_INTERNI_OPIS, KBS.OPIS AS BELEZKE_SUBTYPE_OPIS, KBS.INTERNI_OPIS AS BELEZKE_SUBTYPE_INTERNI_OPIS,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM KUPCIBELEZKE KB
LEFT OUTER JOIN NKUPCIBELEZKE_TYPE KBT ON KBT.ID = KB.TYPE
LEFT OUTER JOIN NKUPCIBELEZKE_SUBTYPE KBS ON KBS.ID = KB.SUBTYPE
LEFT OUTER JOIN KUPCI K ON K.ID = KB.IDKUPCA
);

DROP VIEW V_KUPCI_EMAIL;

CREATE OR REPLACE VIEW V_KUPCI_EMAIL
AS (
SELECT O.ID_OPOMINI AS ID, O.LASTNIK_OBVESCEN, K.ID AS KUPCI_ID, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
E.ID_EMAIL AS EMAIL_ID_EMAIL, E.DATUM_KREIRANJA AS EMAIL_DATUM_KREIRANJA, E.USER_KREIRANJA AS EMAIL_USER_KREIRANJA,
E.TEKST AS EMAIL_TEKST, E.ZADEVA AS EMAIL_ZADEVA, E.POSILJATELJ AS EMAIL_POSILJATELJ, E.PREJEMNIK AS EMAIL_PREJEMNIK, E.STATUS AS EMAIL_STATUS, E.DATUM_POSILJANJA AS EMAIL_DATUM_POSILJANJA, E.AVTOMATSKO_KREIRANJE
AS EMAIL_AVTOMATSKO_KREIRANJE, E.PREJEMNIK_CC AS EMAIL_PREJEMNIK_CC, E.PREJEMNIK_BCC AS EMAIL_PREJEMNIK_BCC, E.PREBRANO AS EMAIL_PREBRANO, E.STATUS_MESSAGE AS EMAIL_STATUS_MESSAGE
FROM OPOMINI O
LEFT OUTER JOIN KUPCI K ON K.ID = O.ID_KUPCA
LEFT OUTER JOIN EMAILS E ON E.ID_EMAIL = O.ID_EMAIL
WHERE O.NPISMO = (SELECT NPISMO FROM NPISMO N WHERE N.NPISMO_TYPE = 'EMAIL')
);

DROP VIEW V_NCARD;

CREATE OR REPLACE VIEW V_NCARD AS (
SELECT N.NCARD, N.ID_LASTNIKA, N.ID_PLOVILA, N.VELJA_OD, N.VELJA_DO, N.SERIALNUMBER, N.NCARD_TYPE, N."COMMENT", N.STATUS, N.NNLOCATION_ID,
NCT.OPIS AS NCARD_TYPE_OPIS, NCT.INTERNI_OPIS AS NCARD_TYPE_INTERNI_OPIS, P.IME AS PLOVILA_IME, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM NCARD N
LEFT OUTER JOIN NCARD_TYPE NCT ON NCT.ID = N.NCARD_TYPE
LEFT OUTER JOIN KUPCI K ON K.ID = N.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = N.ID_PLOVILA
);

DROP VIEW V_NMAPE;

CREATE OR REPLACE VIEW V_NMAPE AS (
  SELECT N.ID_NMAPE, N.ID_LASTNIKA, N.ID_PLOVILA, N.N_MAPE, N.NMAPLOK, N.NNLOCATION_ID,
  NMP.OPIS AS NMAPLOK_OPIS, NMP.INTERNI_OPIS AS NMAPLOK_INTERNI_OPIS, P.IME AS PLOVILA_IME, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
	FROM NMAPE N
  LEFT OUTER JOIN NMAPLOK NMP ON NMP.NMAPLOK = N.NMAPLOK
  LEFT OUTER JOIN PLOVILA P ON P.ID = N.ID_PLOVILA
  LEFT OUTER JOIN KUPCI K ON K.ID = N.ID_LASTNIKA
);

DROP VIEW V_OPOMINI;

CREATE OR REPLACE VIEW V_OPOMINI AS (
	SELECT O.ID_OPOMINI AS ID, O.TEKST, O.DATUM_KREIRANJA, O.USER_KREIRANJA, O.DATUM_SPREMEMBE, O.USER_SPREMEMBE, O.NPISMO, O.ID_VZORCA, O.ID_PLOVILA, O.ID_EMAIL, O.STATUS,
  N.OPIS AS NPISMO_OPIS, N.INTERNI_OPIS AS NPISMO_INTERNI_OPIS, K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
	FROM OPOMINI O
  LEFT OUTER JOIN NPISMO N ON N.NPISMO = O.NPISMO
  LEFT OUTER JOIN KUPCI K ON K.ID = O.ID_KUPCA
);


DROP VIEW V_PAYMENT_TRANSACTION;

CREATE OR REPLACE VIEW V_PAYMENT_TRANSACTION AS (
SELECT PT.ID, PT.ID_SALDKONT, PT.ID_PL_SALDKONT, PT.ID_LASTNIKA, PT.ACCOUNT_FROM, PT.ACCOUNT_TO, PT.AMOUNT, PT.TRANSACTION_DATE, PT.TRANSACTION_MESSAGE, PT.STATUS, PT.PAYMENT_NKNJIZBA, PT."COMMENT",
KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER,
PKN.SLO AS PAYMENT_NKNJIZBA_OPIS, PKN.SALDKONT AS PAYMENT_NKNJIZBA_SALDKONT, SI.N_RACUNA AS SALDKONT_INVOICE_N_RACUNA, 
SI.ZA_PLACILO AS SALDKONT_INVOICE_ZA_PLACILO, SI.PORABLJENO AS SALDKONT_INVOICE_PORABLJENO, SP.N_RACUNA AS SALDKONT_PAYMENT_N_RACUNA
FROM PAYMENT_TRANSACTION PT
LEFT OUTER JOIN KUPCI KU ON KU.ID = PT.ID_LASTNIKA
LEFT OUTER JOIN SALDKONT SI ON SI.ID_SALDKONT = PT.ID_SALDKONT
LEFT OUTER JOIN SALDKONT SP ON SP.ID_SALDKONT = PT.ID_PL_SALDKONT
LEFT OUTER JOIN NKNJIZBA PKN ON PKN.NKNJIZBA = PT.PAYMENT_NKNJIZBA
);

DROP VIEW V_PLOVILABELEZKE;

CREATE OR REPLACE VIEW V_PLOVILABELEZKE AS (
SELECT PB.ID_PLBELEZKE, PB.IDPLOVILA, PB.ID_PRIVEZ, PB.DATUMKREIRANJA, PB.USERKREIRANJA, PB.BELEZKA, PB.VELJAVNA, PB.TYPE, PB.SUBTYPE,
PBT.OPIS AS BELEZKE_TYPE_OPIS, PBT.INTERNI_OPIS AS BELEZKE_TYPE_INTERNI_OPIS, PBS.OPIS AS BELEZKE_SUBTYPE_OPIS, PBS.INTERNI_OPIS AS BELEZKE_SUBTYPE_INTERNI_OPIS, 
PL.IME AS PLOVILA_IME,NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_PRIVEZ, K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM PLOVILABELEZKE PB
LEFT OUTER JOIN NPLOVILABELEZKE_TYPE PBT ON PBT.ID = PB.TYPE
LEFT OUTER JOIN NPLOVILABELEZKE_SUBTYPE PBS ON PBS.ID = PB.SUBTYPE
LEFT OUTER JOIN PLOVILA PL ON PL.ID = PB.IDPLOVILA
LEFT OUTER JOIN KUPCI K ON K.ID = PL.ID_LASTNIKA
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = PB.ID_PRIVEZ
);

DROP VIEW V_PREGLEDI;

CREATE OR REPLACE VIEW V_PREGLEDI AS (
  SELECT P.ID_PREGLEDI, P.ID_LASTNIKA, P.ID_PLOVILA, P.NSTANJE, P.DATUM, P.CAS, P.KOMENTAR, P.KOMENTAR1, P.USER_KREIRANJA, P.LASTNIK_OBVESCEN, P.N_PRIVEZA, P.OBJEKT, P.ID_STORITVE, P.STATUS,
  PL.IME AS PLOVILA_IME, NS.OPIS AS NSTANJE_OPIS, NS.INTERNI_OPIS AS NSTANJE_INTERNI_OPIS, NS.NSTANJE_TYPE AS NSTANJE_TYPE, NNP.NNLOCATION_ID, KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER
	FROM PREGLEDI P
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KU ON KU.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NSTANJE NS ON NS.NSTANJE = P.NSTANJE
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.OBJEKT = P.OBJEKT AND NP.N_PRIVEZA = P.N_PRIVEZA
  LEFT OUTER JOIN NNPOMOL NNP ON NNP.SIFRA = NP.KATEGORIJA
);

DROP VIEW V_S_DOKUMENT;

CREATE OR REPLACE VIEW V_S_DOKUMENT
AS (
SELECT SD.ID_DOKUMENT, SD.STEVILKA, SD.DATUM, SD.DEL_NALOG, SD.PR_RACUN, SD.UPORABNIK, SD.DT_VPISA, SD.ST_DOKUMENTA, SD.TIP, SD.ID_LOKACIJA, SD.DOBAVITELJ, SD.DT_SPREMEMBE,
SD.OPOMBA, SD.STATUS, SD.UPOR_SPREM, SD.PREJEMNIK, SD.ID_STORITVE, SD.NGRUPA, SD.REF_DOK, SD.PRENOS,
NG.OPIS AS NNGRUSTO_OPIS, MD.STEVILKA AS M_DE_NA_STEVILKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM S_DOKUMENT SD
LEFT OUTER JOIN NNGRUSTO NG ON NG.NGRUPA = SD.NGRUPA
LEFT OUTER JOIN M_DE_NA MD ON MD.ID_DN = SD.DEL_NALOG
LEFT OUTER JOIN KUPCI K ON K.ID = SD.DOBAVITELJ
);

DROP VIEW V_SMS;

CREATE OR REPLACE VIEW V_SMS
AS (
SELECT S.ID, S.RECEIVER, S.CONTENT, S.STATUS, S.SMS_FILE, S.DATE_CREATED, S.USER_CREATED, S.STATUS_MESSAGE,
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM SMS S
LEFT OUTER JOIN (SELECT ID_KUPCA, ID_SMS, NPISMO, RANK() OVER (PARTITION BY ID_SMS ORDER BY ID_OPOMINI ASC) RNK FROM OPOMINI) O ON (O.ID_SMS = S.ID AND O.RNK = 1 AND O.NPISMO = 'S')
LEFT OUTER JOIN KUPCI K ON O.ID_KUPCA = K.ID
);

DROP VIEW V_S_OBRACUN;

CREATE OR REPLACE VIEW V_S_OBRACUN AS (
  SELECT SO.ID_OBRACUN, SO.DEL_NALOG, SO.ID_ARTIKEL, SO.KOLICINA, SO.ID_ENOTA, SO.CENA, SO.DAV_STOPNJA, SO.ZN_DAVKA, SO.ZN_BREZ_DAVKA, 
  SO.SKUPAJ, SO.ID_PROMET, SO.RABAT, SO.MARZA, SO.OPIS, SO.ZAKLJUCEN, SO.ID_LASTNIKA, SO.ID_PLOVILA,
  DN.STEVILKA AS M_DE_NA_STEVILKA, DN.DATUM_DN AS M_DE_NA_DATUM_DN, DN.DATUM_KREIRANJA AS M_DE_NA_DATUM_KREIRANJA, 
  SA.NAZIV AS S_ARTIKLI_NAZIV, SA.NAZIV1 AS S_ARTIKLI_NAZIV1, PL.IME AS PLOVILA_IME, KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER
	FROM S_OBRACUN SO
  LEFT OUTER JOIN M_DE_NA DN ON DN.ID_DN = SO.DEL_NALOG
  LEFT OUTER JOIN S_ARTIKLI SA ON SA.ID_ARTIKEL = SO.ID_ARTIKEL
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = SO.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KU ON KU.ID = SO.ID_LASTNIKA
);

DROP VIEW V_S_RAZNI_DOK;

CREATE OR REPLACE VIEW V_S_RAZNI_DOK AS (
SELECT SRD.ID_RAZNI_DOK, SRD.TIP, SRD.DATUM, SRD.STEVILKA, SRD.PARTNER, SRD.ST_DOKUMENTA, SRD.OPOMBA, SRD.NOGA, SRD.PLOVILO, SRD.ID_DN, SRD.NGRUPA, SRD.STATUS,
NG.OPIS AS NNGRUSTO_OPIS, MD.STEVILKA AS M_DE_NA_STEVILKA, PL.IME AS PLOVILA_IME, KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER
FROM S_RAZNI_DOK SRD
LEFT OUTER JOIN NNGRUSTO NG ON NG.NGRUPA = SRD.NGRUPA
LEFT OUTER JOIN M_DE_NA MD ON MD.ID_DN = SRD.ID_DN
LEFT OUTER JOIN KUPCI KU ON KU.ID = SRD.PARTNER
LEFT OUTER JOIN PLOVILA PL ON PL.ID = SRD.PLOVILO
);

DROP VIEW V_STORITVE_INCOME;

CREATE OR REPLACE VIEW V_STORITVE_INCOME AS (
	SELECT M.ID_STORITVE_INCOME, M.ID_STORITVE, M.ID_POGODBE, M.ID_VPS, M.ID_OBRACUNA, M.ID_PRIVEZ, M.ID_LASTNIK, M.ID_PLOVILA, M.ID_REZERVACIJE, 
  M.ID_RACUN_DATA, M.DATUM, M.ZNESEK, M.BRUTO, M.BRUTO_FULL, M.BRUTO_BERTH, M.ZNESEK_FULL, M.ZNESEK_BERTH,
  MS.STORITEV AS M_STORITVE_STORITEV, MS.KAT AS M_STORITVE_KAT, MS.TIMEKAT AS M_STORITVE_TIMEKAT, MS.N_RACUNA AS M_STORITVE_N_RACUNA,
  MN.OPIS AS M_NNSTOMAR_OPIS, MN.INTERNI_OPIS AS M_NNSTOMAR_INTERNI_OPIS, MN.WEB_APP_USE AS M_NNSTOMAR_WEB_APP_USE, MN.BERTH_YIELD AS M_NNSTOMAR_BERTH_YIELD,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, 
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  P.IME AS PLOVILA_IME, P.DOLZINA AS PLOVILA_DOLZINA, P.SIRINA AS PLOVILA_SIRINA,
  NP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NP.DOLZINA AS NNPRIVEZ_DOLZINA, NP.SIRINA AS NNPRIVEZ_SIRINA, RD.N_RACUNA AS RACUN_DATA_N_RACUNA
	FROM M_STORITVE_INCOME M
  LEFT OUTER JOIN M_STORITVE MS ON MS.ID_STORITVE = M.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR MN ON MN.SIFRA = MS.STORITEV
  LEFT OUTER JOIN KUPCI K ON K.ID = M.ID_LASTNIK
  LEFT OUTER JOIN PLOVILA P ON P.ID = M.ID_PLOVILA
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = M.ID_PRIVEZ
  LEFT OUTER JOIN RACUN_DATA RD ON RD.ID_RACUN_DATA = M.ID_RACUN_DATA
);

DROP VIEW V_ASSISTANCE;

CREATE OR REPLACE VIEW V_ASSISTANCE
AS (
SELECT A.ID, A.ID_LASTNIKA, A.ASSISTANCE_TYPE, A.ASSISTANCE_DATE, A.ASSISTANCE_COMMENT, 
N.OPIS AS NNASSISTANCE_OPIS, N.INTERNI_OPIS AS NNASSISTANCE_INTERNI_OPIS, N.ALARM AS NNASSISTANCE_ALARM, N.EMAIL AS NNASSISTANCE_EMAIL,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM ASSISTANCE A
LEFT OUTER JOIN NNASSISTANCE N ON N.ID = A.ASSISTANCE_TYPE
LEFT OUTER JOIN KUPCI K ON A.ID_LASTNIKA = K.ID
);

DROP VIEW V_PRESPR;

CREATE OR REPLACE VIEW V_PRESPR
AS (
SELECT P.ID, P.LOKACIJA, P.DATUM, P.NTIP, P.DOLZINA, P.IME_PLOVILA, P.REGISTRSKA_N, P.NZASTAVA, P.BELEZKA, P.OBJEKT, P.N_PRIVEZA, P.NTITLE, P.IME, P.PRIIMEK, P.NASLOV, P.MESTO, P.POSTA, P.NDRZAVA,
P.AVTOMOBIL, P.TOVORNJAK, P.PRIKOLICA, P.KAMPER, PREVOZNIK, P.N_OSEB, P.TIP_DOG, P.ID_LASTNIKA, P.ID_PLOVILA, P.STATUS, P.OSN_PRIVEZ, P.ID_MASTER, P.ID_SLAVE, P.EMAIL, P.TELEPHONE, P.HAS_BOAT,
P.ID_MARINA_EVENT, P.STATE, P.PROIZVAJALEC, P.ID_PRIVEZ, P.TYPE, P.NNLOCATION_ID,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (P.IME || ' ' || P.PRIIMEK) ELSE (P.PRIIMEK || ' ' || P.IME) END) AS OWNER,
PT.DESCRIPTION AS TYPE_DESCRIPTION, TP.OPIS AS NNTIP_OPIS, TP.INTERNI_OPIS AS NNTIP_INTERNI_OPIS, TI.OPIS AS NNTITLE_OPIS, TI.INTERNI_OPIS AS NNTITLE_INTERNI_OPIS
FROM PRESPR P
LEFT OUTER JOIN PRESPR_TYPE PT ON PT.CODE = P.TYPE
LEFT OUTER JOIN NNTIP TP ON TP.SIFRA = P.NTIP
LEFT OUTER JOIN NNTITLE TI ON TI.SIFRA = P.NTITLE
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1427, SYSDATE, '5.5', 1347, 'Owner column')
;