DROP VIEW V_DELAVCI;

CREATE OR REPLACE VIEW V_DELAVCI AS (
	SELECT D.ID_DELAVCI, D.ID_STORITVE, D.SIFRA, D.DATUM, D.STEVILO_UR, D.HOURS_PLANNED, D.KOMENTAR, D.HOUR_FROM_PLANNED, D.ID_TIPSERVIS,
  D.STATUS_PLAN, D.STATUS_ACTUAL, D.DATE_APPROVED_PLAN, D.USER_APPROVED_PLAN, D.DATE_APPROVED_ACTUAL, D.USER_APPROVED_ACTUAL,
  TSP.DESCRIPTION AS STATUS_PLAN_DESCRIPTION, TSP.COLOR_PLAN AS STATUS_PLAN_COLOR, TSP.TEXT_COLOR_PLAN AS STATUS_PLAN_TEXT_COLOR, 
  TSA.DESCRIPTION AS STATUS_ACTUAL_DESCRIPTION, TSA.COLOR_ACTUAL AS STATUS_ACTUAL_COLOR, TSA.TEXT_COLOR_ACTUAL AS STATUS_ACTUAL_TEXT_COLOR, MS.ID_DN, MNS.OPIS AS NNSTOMAR_OPIS, MD.STEVILKA AS M_DE_NA_STEVILKA,
  AST.NAME AS WORK_ORDER_ASSET_NAME, PL.IME AS WORK_ORDER_BOAT_NAME,
  ND.NUSER AS NNDELAVC_NUSER, ND.MANAGER AS NNDELAVC_MANAGER, ND.OPIS AS NNDELAVC_OPIS, ND.INTERNI_OPIS AS NNDELAVC_INTERNI_OPIS, ND.PRICE AS NNDELAVC_PRICE, ND.TYPE AS NNDELAVC_TYPE, 
  ND.NNLOCATION_ID AS NNDELAVC_NNLOCATION_ID, ND.ID AS NNDELAVC_ID, ND.SELL_PRICE AS NNDELAVC_SELL_PRICE,
  KD.ID AS NNDELAVC_KUPCI_ID, KD.IME AS NNDELAVC_KUPCI_IME, KD.PRIIMEK AS NNDELAVC_KUPCI_PRIIMEK, KD.MANAGER AS NNDELAVC_KUPCI_MANAGER,
  TS.OPIS AS TIPSERVIS_OPIS, TS.INTERNAL AS TIPSERVIS_INTERNAL, MT.ID_MAINTENANCE_TASK AS MAINTENANCE_TASK_ID, MT.ID_CHECKLIST AS MAINTENANCE_TASK_ID_CHECKLIST, CH.NAME AS MAIN_TASK_CHECKLIST_NAME, 
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') AS DATE_FROM_PLANNED,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') + D.HOURS_PLANNED/24 AS DATE_TO_PLANNED,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') AS DATE_FROM_ACTUAL,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') + D.STEVILO_UR/24 AS DATE_TO_ACTUAL
  FROM DELAVCI D
  LEFT OUTER JOIN M_STORITVE MS ON MS.ID_STORITVE = D.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR MNS ON MNS.SIFRA = MS.STORITEV
  LEFT OUTER JOIN M_DE_NA MD ON MD.ID_DN = MS.ID_DN
  LEFT OUTER JOIN ASSET AST ON AST.ID_ASSET = MD.ID_ASSET 
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = MD.ID_PLOVILA
  LEFT OUTER JOIN NNDELAVC ND ON ND.SIFRA = D.SIFRA
  LEFT OUTER JOIN KUPCI KD ON KD.ID = ND.ID_LASTNIKA
  LEFT OUTER JOIN TIPSERVIS TS ON TS.SIFRA = D.ID_TIPSERVIS
  LEFT OUTER JOIN MAINTENANCE_TASK MT ON MT.ID_STORITVE = D.ID_STORITVE
  LEFT OUTER JOIN CHECKLIST CH ON CH.ID_CHECKLIST = MT.ID_CHECKLIST
  LEFT OUTER JOIN WORKER_TASK_STATUS TSP ON TSP.ID_WORKER_TASK_STATUS = D.STATUS_PLAN
  LEFT OUTER JOIN WORKER_TASK_STATUS TSA ON TSA.ID_WORKER_TASK_STATUS = D.STATUS_ACTUAL
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1541, SYSDATE, '5.5', 1461, 'VDelavci')
;
