ALTER TABLE FB_VIEW_PRODUCT
ADD FILE_NAME VARCHAR2(200 CHAR);

ALTER TABLE FB_VIEW_PRODUCT
ADD FILE_DATA BLOB;

ALTER TABLE FB_VIEW_PRODUCT
ADD FILE_REFERENCE VARCHAR2(20 CHAR);

DROP VIEW V_FB_VIEW_PRODUCT;

CREATE OR REPLACE VIEW V_FB_VIEW_PRODUCT AS (
SELECT FP.ID_FB_VIEW_PRODUCT, FP.ID_FB_VIEW_GROUP, FP.ID_ARTIKEL, FP.SORT, FP.COLOR, FP.FILE_NAME, FP.FILE_DATA, FP.FILE_REFERENCE,
FG.ID_FB_LOCATION, FG.DESCRIPTION AS GROUP_DESCRIPTION, FG.ACTIVE AS GROUP_ACTIVE, S.NAZIV1 AS PRODUCT_DESCRIPTION, S.AUTO_NOTE AS PRODUCT_AUTO_NOTE
FROM FB_VIEW_PRODUCT FP
LEFT OUTER JOIN FB_VIEW_GROUP FG ON FG.ID_FB_VIEW_GROUP = FP.ID_FB_VIEW_GROUP
LEFT OUTER JOIN S_ARTIKLI S ON S.ID_ARTIKEL = FP.ID_ARTIKEL
);

DROP VIEW V_S_ARTIKLI;

CREATE OR REPLACE VIEW V_S_ARTIKLI
AS (
SELECT SA.ID_ARTIKEL, SA.ID_ENOTA, SA.ID_DAVEK, SA.ID_GRUPA, SA.NAZIV, SA.NAZIV1, SA.BAR_KODA, SA.MIN_ZALOGA, SA.MIN_IZDAJA, SA.CENA_SKL, SA.CENA_MP, SA.CENA_VP, SA.CENA_DEM, SA.DT_VPISA,
SA.DOBAVITELJ, SA.UPOR_VPIS, SA.UPOR_SPREM, SA.DAV_STOPNJA, SA.DT_SPREMEMBE, SA.KONTO, SA.LOKACIJA, SA.SIFRA_DOB, SA.V_UPORABI, SA.PRENOS, SA.LOKACIJA1, SA.LOKACIJA2, SA.CENAZDDV, SA.VRSTA,
SA.INTERNI_OPIS, SA.PROIZVAJALEC, SA.NNLOCATION_ID, SA.SALE, SA.STOCKS, SA.RECIPE, SA.FB, SA.PORTAL, SA.DESCRIPTION, SA.AUTO_NOTE, SA.ALLOW_PRICE_CHANGE, SA.COLOR, SA.ID_LOKACIJA,
SE.NAZIV AS S_ENOTE_NAZIV, SE.OSN_ENOTA AS S_ENOTE_OSN_ENOTA, SD.OPIS AS S_DAVEK_OPIS, SG.NAZIV AS S_GRUPE_NAZIV, SG.SERVICE AS S_GRUPE_SERVICE, 
SG.COMMISSION_PERCENTAGE AS S_GRUPE_COMMISSION_PERCENTAGE, SG.OWNER_TYPE AS S_GRUPE_OWNER_TYPE, SG.ROUNDING AS S_GRUPE_ROUNDING,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (SUP.IME || ' ' || SUP.PRIIMEK) ELSE (SUP.PRIIMEK || ' ' || SUP.IME) END) AS SUPPLIER_NAME
FROM S_ARTIKLI SA
LEFT OUTER JOIN S_DAVEK SD ON SD.ID_DAVEK = SA.ID_DAVEK
LEFT OUTER JOIN S_ENOTE SE ON SE.ID_ENOTA = SA.ID_ENOTA
LEFT OUTER JOIN S_GRUPE SG ON SG.ID_GRUPA = SA.ID_GRUPA
LEFT OUTER JOIN KUPCI SUP ON SUP.ID = SA.DOBAVITELJ
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2122, SYSDATE, '5.5', 2042, 'FB product image')
;
