DROP TABLE EMAIL_TEMPLATE_TIMER;
DROP SEQUENCE EMAIL_TEMPLATE_TIMER_SEQ;

DROP TABLE EMAIL_TEMPLATE;
DROP SEQUENCE EMAIL_TEMPLATE_SEQ;
DROP VIEW V_EMAIL_TEMPLATE;

DROP TABLE TEMPLATE_QUERY;
DROP SEQUENCE TEMPLATE_QUERY_SEQ;

INSERT INTO NNTEMPLATE(SIFRA, OPIS, INTERNI_OPIS, AKT) 
VALUES ('ESE', 'Email sender', 'Email sender', 'Y');

INSERT INTO NNTEMPLATE(SIFRA, OPIS, INTERNI_OPIS, AKT) 
VALUES ('ERE', 'Email receiver', 'Email receiver', 'Y');

CREATE TABLE TEMPLATE_QUERY_TIMER (
	ID_TEMPLATE_QUERY_TIMER NUMBER NOT NULL,
	NAME VARCHAR2(100 CHAR),
	ID_TEMPLATE NUMBER NOT NULL,
	ID_QUERY NUMBER,
	ID_TIMER_DATA NUMBER NOT NULL,
	DATE_CREATED DATE,
	USER_CREATED VARCHAR2(30 CHAR),
	DATE_CHANGED DATE,
	USER_CHANGED VARCHAR2(30 CHAR),
	ACT VARCHAR2(1 CHAR),
	CONSTRAINT TPL_QRY_TMR_ID_TEMPLATE_FK FOREIGN KEY (ID_TEMPLATE) REFERENCES TEMPLATE(ID_TEMPLATE),
	CONSTRAINT TPL_QRY_TMR_ID_QUERY_FK FOREIGN KEY (ID_QUERY) REFERENCES QUERY(ID_QUERY),
	CONSTRAINT TPL_QRY_TMR_ID_TIMER_DATA_FK FOREIGN KEY (ID_TIMER_DATA) REFERENCES TIMER_DATA(ID_TIMER_DATA),
	CONSTRAINT TEMPLATE_QUERY_TIMER_PK PRIMARY KEY (ID_TEMPLATE_QUERY_TIMER)
);

CREATE SEQUENCE TEMPLATE_QUERY_TIMER_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_TEMPLATE_QUERY_TIMER AS
SELECT TQ.ID_TEMPLATE_QUERY_TIMER, TQ.NAME, TE.NAME AS TEMPLATE_NAME, QU.NAME AS QUERY_NAME, TD.TIMER_ID AS TIMER_ID,
TQ.DATE_CREATED, TQ.USER_CREATED, TQ.DATE_CHANGED, TQ.USER_CHANGED, TQ.ACT
FROM TEMPLATE_QUERY_TIMER TQ
LEFT OUTER JOIN TEMPLATE TE ON TE.ID_TEMPLATE = TQ.ID_TEMPLATE
LEFT OUTER JOIN QUERY QU ON QU.ID_QUERY = TQ.ID_QUERY
LEFT OUTER JOIN TIMER_DATA TD ON TD.ID_TIMER_DATA = TQ.ID_TIMER_DATA;

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(481, SYSDATE, '5.5', 401, 'Predloge in casovniki');