CREATE TABLE DOGODKI_DETAIL(
ID_DOGODKI_DETAIL NUMBER NOT NULL,
ID_DOGODKA NUMBER NOT NULL,
ID_PRIVEZ NUMBER NOT NULL,
CONSTRAINT PK_DOGODKI_DETAIL PRIMARY KEY(ID_DOGODKI_DETAIL)
);

CREATE SEQUENCE DOGODKI_DETAIL_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_DOGODKI AS (
	SELECT CONCAT(CONCAT(D.ID, '-'), NVL(DD.ID_DOGODKI_DETAIL, '0')) AS V_DOGODKI_ID, 
  D.ID, D.ID_LASTNIKA, D.ID_PLOVILA, D.DATUM_ZACETKA, D.KATEGORIJA_DOGODKA, 
  (CASE WHEN DD.ID_DOGODKI_DETAIL IS NULL THEN D.OBJEKT ELSE (SELECT OBJEKT FROM NNPRIVEZ WHERE ID_PRIVEZ = DD.ID_PRIVEZ) END) AS OBJEKT,
  (CASE WHEN DD.ID_DOGODKI_DETAIL IS NULL THEN D.N_PRIVEZA ELSE (SELECT N_PRIVEZA FROM NNPRIVEZ WHERE ID_PRIVEZ = DD.ID_PRIVEZ) END) AS N_PRIVEZA,
  D.STORITEV, D.N_POGODBE, D.PREDVIDENI_DATUM_KONCA, D.DATUM_KONCA,
  D.DATUM_KREIRANJA, D.USER_KREIRANJA, D.DATUM_SPREMEMBE, D.USER_SPREMEMBE, D.ID_RFID_DATA, D.DAILY, ND.OPIS AS NDOGODEK_OPIS, ND.INTERNI_OPIS AS NDOGODEK_INTERNI_OPIS,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, P.IME AS PLOVILA_IME
	FROM DOGODKI D
  LEFT OUTER JOIN NDOGODEK ND ON ND.NDOGODEK = D.KATEGORIJA_DOGODKA
  LEFT OUTER JOIN KUPCI K ON K.ID = D.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA P ON P.ID = D.ID_PLOVILA
  FULL OUTER JOIN DOGODKI_DETAIL DD ON DD.ID_DOGODKA = D.ID
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (729, SYSDATE, '5.5', 649, 'Dogodki detail');