CREATE TABLE QUESTION (
	ID NUMBER NOT NULL,
	TYPE NUMBER NOT NULL,
	NAME VARCHAR2(300 CHAR),
	QUESTION VARCHAR2(2000 CHAR),
	ACT VARCHAR2(1 CHAR),
	CONSTRAINT QUESTION_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE QUESTION_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE QUESTION_ANSWER_CHOICE (
	ID NUMBER NOT NULL,
	ID_QUESTION NUMBER NOT NULL,
	ANSWER VARCHAR2(500 CHAR) NOT NULL,
	SORT NUMBER,
	CONSTRAINT QAC_QUESTION_FK FOREIGN KEY (ID_QUESTION) REFERENCES QUESTION(ID),
	CONSTRAINT QUESTION_ANSWER_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE QUESTION_ANSWER_CHOICE_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE SECTION (
	ID NUMBER NOT NULL,
	NAME VARCHAR2(300 CHAR) NOT NULL,
	SECTION VARCHAR2(1000 CHAR),
	ACT VARCHAR2(1 CHAR),
	CONSTRAINT SECTION_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE SECTION_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE QUESTIONNAIRE (
	ID NUMBER NOT NULL,
	NAME VARCHAR2(300 CHAR) NOT NULL,
	HEADER VARCHAR2(2000 CHAR),
	FOOTER VARCHAR2(2000 CHAR),
	ACT VARCHAR2(1 CHAR),
	CONSTRAINT QUESTIONNAIRE_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE QUESTIONNAIRE_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE QUESTIONNAIRE_SECTION (
	ID NUMBER NOT NULL,
	ID_QUESTIONNAIRE NUMBER NOT NULL,
	ID_SECTION NUMBER NOT NULL,
	SORT NUMBER,
	CONSTRAINT QS_QUESTIONNAIRE_FK FOREIGN KEY (ID_QUESTIONNAIRE) REFERENCES QUESTIONNAIRE(ID),
	CONSTRAINT QS_SECTION_FK FOREIGN KEY (ID_SECTION) REFERENCES SECTION(ID),
	CONSTRAINT QUESTIONNAIRE_SECTION_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE QUESTIONNAIRE_SECTION_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_QUESTIONNAIRE_SECTION AS (
	SELECT QS.ID, QS.ID_QUESTIONNAIRE, QS.ID_SECTION, QS.SORT, QU.NAME AS QUESTIONNAIRE_NAME, SC.NAME AS SECTION_NAME
	FROM QUESTIONNAIRE_SECTION QS
  LEFT OUTER JOIN QUESTIONNAIRE QU ON QU.ID = QS.ID_QUESTIONNAIRE
  LEFT OUTER JOIN SECTION SC ON SC.ID = QS.ID_SECTION
);

CREATE TABLE SECTION_QUESTION (
	ID NUMBER NOT NULL,
	ID_QUESTIONNAIRE NOT NULL,
	ID_SECTION NUMBER NOT NULL,
	ID_QUESTION NUMBER NOT NULL,
	SORT NUMBER,
	CONSTRAINT SC_QUESTIONNAIRE_FK FOREIGN KEY (ID_QUESTIONNAIRE) REFERENCES QUESTIONNAIRE(ID),
	CONSTRAINT SC_SECTION_FK FOREIGN KEY (ID_SECTION) REFERENCES SECTION(ID),
	CONSTRAINT SC_QUESTION_FK FOREIGN KEY (ID_QUESTION) REFERENCES QUESTION(ID),
	CONSTRAINT SECTION_QUESTION_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE SECTION_QUESTION_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_SECTION_QUESTION AS (
	SELECT SQ.ID, SQ.ID_SECTION, SQ.ID_QUESTION, SQ.ID_QUESTIONNAIRE, SQ.SORT, Q.NAME AS QUESTIONNAIRE_NAME, SC.NAME AS SECTION_NAME, QU.NAME AS QUESTION_NAME
	FROM SECTION_QUESTION SQ
  LEFT OUTER JOIN QUESTIONNAIRE Q ON Q.ID = SQ.ID_QUESTIONNAIRE
  LEFT OUTER JOIN SECTION SC ON SC.ID = SQ.ID_SECTION
  LEFT OUTER JOIN QUESTION QU ON QU.ID = SQ.ID_QUESTION
);

CREATE TABLE QUESTIONNAIRE_ANSWER (
	ID NUMBER NOT NULL,
	ID_QUESTIONNAIRE NUMBER NOT NULL,
	ID_QUESTION NUMBER NOT NULL,
	ID_MARINA_EVENT NUMBER,
	STRING_ANSWER VARCHAR2(2000 CHAR),
	DATE_ANSWER DATE,
	NUMBER_ANSWER NUMBER,
	CONSTRAINT QA_QUESTIONNAIRE_FK FOREIGN KEY (ID_QUESTIONNAIRE) REFERENCES QUESTIONNAIRE(ID),
	CONSTRAINT QA_QUESTION_FK FOREIGN KEY (ID_QUESTION) REFERENCES QUESTION(ID),
	CONSTRAINT QUESTIONNAIRE_ANSWER_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE QUESTIONNAIRE_ANSWER_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (750, SYSDATE, '5.5', 670, 'Vprasalniki');