CREATE OR REPLACE VIEW V_NAJAVE AS (
SELECT DISTINCT N.ID AS ID_NAJAVE, N.ID_DVIGALA, N.ID_LASTNIKA, N.ID_PLOVILA, N.ID_STORITVE, N.SIFRA_DVIGALA, N.SIFRA_STORITVE, N.VRSTA_NAJAVE, N.DATUM, N.URA_OD, N.URA_DO, N.DATUM_OD, N.DATUM_DO,
N.LASTNIK_OBVESCEN, N.ID_PRIVEZ, NP.N_PRIVEZA, N.KOMENTAR, N.NAVODILO, N.ID_DN,
S.COMPLETE, M.OPIS AS STORITEV, P.IME AS IME_PLOVILA, P.TEZA AS TEZA_PLOVILA, NVL(K.PRIIMEK, '') || ' ' || NVL(K.IME, '') AS LASTNIK, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME,
ND.OPIS AS NNDVIGAL_OPIS, ND.INTERNI_OPIS AS NNDVIGAL_INTERNI_OPIS, ND.NOSILNOST AS NNDVIGAL_NOSILNOST
FROM NAJAVE N
LEFT JOIN M_NNSTOMAR M ON N.SIFRA_STORITVE = M.SIFRA
LEFT JOIN PLOVILA P ON N.ID_PLOVILA = P.ID
LEFT JOIN KUPCI K ON N.ID_LASTNIKA = K.ID
LEFT JOIN M_STORITVE S ON N.ID_STORITVE = S.ID_STORITVE
LEFT JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = N.ID_PRIVEZ
LEFT JOIN NNDVIGAL ND ON ND.ID = N.ID_DVIGALA
);

CREATE OR REPLACE VIEW V_PLOVILA AS (
SELECT P.ID, P.ID_LASTNIKA, P.N_POGODBE, P.FEKALNI_TANK, P.NTIP, P.IME, P.MATICNA_LUKA, P.REGISTRSKA_N, P.NZASTAVA, P.DOLZINA, P.SIRINA, P.VISINA, P.TEZA, P.GREZ, P.PODSTAVEK, P.VALUTA, P.VREDNOST,
P.PROIZVAJALEC, P.LETO_IZDELAVE, P.KONSTRUKCIJSKI_MATERIAL, P.TIP_MOTORJA, P.MOC_MOTORJA, P.ENOTA_MOCI_MOTORJA, P.STEVILO_MOTORJEV, P.N_MOTORJA_1, P.N_MOTORJA_2, P.N_MOTORJA_3, P.ZAVAROVALNICA,
P.N_ZAVAROVALNE_POLICE, P.ZAVAROVANO_DO, P.ZAVAROVALNA_VSOTA, P.VALUTA_ZAVAROVALNE_VSOTE, P.BELEZKA, P.BELEZKA_2, P.POGODBENI_OBJEKT_PRIVEZA, P.POGODBENA_N_PRIVEZA, P.POGODBA_OD, P.POGODBA_DO,
P.TRENUTNI_OBJEKT_PRIVEZA, P.TRENUTNA_N_PRIVEZA, P.TRENUTNO_OD, P.TRENUTNO_DO, P.PLOVNO_DOVOLJENJE, P.KRAJ_PLOVNEGA_DOVOLJENJA, P.DATUM_PLOVNEGA_DOVOLJENJA, P.N_DELOVNEGA_NALOGA, P.STORITVE,
P.USER_KREIRANJA, P.DATUM_KREIRANJA, P.USER_SPREMEMBE, P.DATUM_SPREMEMBE, P.N_ZIMOVANJE, P.DATUM_PREK_ZIMOVANJA, P.BOOKING, P.STEVILO_KABIN, P.MODEL, P.STEVILO_LEZISC, P.GORIVO, P.MOC_MOTORJA_1,
P.MOC_MOTORJA_2, P.ID_TIPA_MOTORJA_1, P.ID_TIPA_MOTORJA_2, P.ID_TIPA_MOTORJA_3, P.ENOTA_MOCI_MOTORJA_1, P.ENOTA_MOCI_MOTORJA_2, P.ENOTA_MOCI_MOTORJA_3, P.ID_PROIZVAJALCA, P.ID_KONSTR_MAT,
P.ID_PODSTAVKA, P.ID_TIPA, P.TIP_PLOVILA, P.DAT_PLOV_DOV, P.DATUM_ZAVAROVANJE, P.POOBLASTILO_DO, P.VPIS_LIST_DO, P.DATUM_MENJ_OLJA, P.DATUM_RED_SERVIS, P.ST_UR_MOTORJA, P.PROVIZIJA_DELITEV,
P.KASKO_ZAVAROVANJE_DO, P.PROVIZIJA, P.OCISCENA, P.RFID, P.PODALJSA, P.DOVOLJENJE, P.LASTNISTVO, P.ID_PLOVILA_CARINA, P.ACT, P.PLOVILA_IZVOR, P.RFIDSIGNAL, P.LAST_PORT, P.COLOR, P.ID_PRIVEZ, 
P.PROPULSION_TYPE, P.PAYMENT_TYPE, P.UNDERWATER_HULL, P.TOP_SIDES, P.DECK, P.SUPER_STRUCTURE, P.SURFACE, P.HULL_ID_NUMBER, P.VRSKUP, P.KUPCI_CREDIT_CARD_ID, P.BOAT_PRICE, P.BRUTO_TEZA, 
P.ST_POTNIKOV, P.LOADING_WEIGHT, P.LOADING_VOLUME,
NT.OPIS AS NNTIP_OPIS, NT.INTERNI_OPIS AS NNTIP_INTERNI_OPIS, ND.OPIS AS NNDRZAVE_OPIS, ND.INTERNI_OPIS AS NNDRZAVE_INTERNI_OPIS, NVK.OPIS AS NNVRSKUP_OPIS, NVK.INTERNI_OPIS AS NNVRSKUP_INTERNI_OPIS
FROM PLOVILA P
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNVRSKUP NVK ON NVK.SIFRA = P.VRSKUP
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (891, SYSDATE, '5.5', 811, 'VNajave');